<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent('onPrepareContent', 'plg_photospot');

function plg_photospot_get_option($key, $default) {
	$db =& JFactory::getDBO();
	$db->setQuery("SELECT `value` FROM #__photospot_misc WHERE `key` = " . $db->Quote($key));
	$result = $db->loadResult();
	return empty($result) ? $default : $result;
}

function plg_photospot_cb($all) {
	static $com_exists = null;
	static $params = null;
	static $db = null;
	static $aid = null;
	$show_gallery_filename = JPATH_SITE . '/components/com_photospot/show_gallery.php';

	if ($com_exists === null) {
		$com_exists = file_exists($show_gallery_filename);
		if ($com_exists) {
			$plugin =& JPluginHelper::getPlugin('content', 'photospot');
			$params = new JParameter($plugin->params);

			$db =& JFactory::getDBO();

			$user =& JFactory::getUser();
			$aid = (int) $user->get('aid', 0);
		}
	}

	$msg_fmt = '<div class="photospot_msg">{%s}</div>';

	if (!$com_exists)
		return sprintf($msg_fmt, JText::_('Photo Spot component is missing'));


	preg_match_all('~(\w+)\s*=\s*"([^"]*)"~', $all[1], $m);

	$vars = array();
	for ($i = 0, $len = count($m[0]); $i < $len; $i++)
		$vars[strtolower($m[1][$i])] = $m[2][$i];


	$gallery = null;

	if (!empty($vars['access']) && $aid < intval($vars['access'])) {
		$error_msg = plg_photospot_get_option('error_msg_unauthorized', 'You are not authorized to access this gallery');
		return sprintf($msg_fmt, JText::_($error_msg));
	}

	// load gallery from the menu parameter gallery id
	$handle = trim(@$vars['gid']);
	if ($handle != '' && $handle != '0') {
		$db->setQuery("SELECT * FROM #__photospot_galleries WHERE id = " . intval($handle));
		$gallery = $db->loadObject();

		if ($gallery === null)
			return sprintf($msg_fmt, JText::_('Gallery not found'));
	}

	// load gallery from the menu parameter gallery name
	if ($gallery === null) {
		$handle = trim(@$vars['gname']);
		if ($handle != '') {
			$db->setQuery("SELECT * FROM #__photospot_galleries WHERE name = " . $db->Quote($handle));
			$gallery = $db->loadObject();

			if ($gallery === null)
				return sprintf($msg_fmt, JText::_('Gallery not found'));
		}
	}


	// check for gallery availability
	if ($gallery !== null && $gallery->published == '0') {
		$error_msg = plg_photospot_get_option('error_msg_unpublished_gallery', 'Gallery is unavailable');
		return sprintf($msg_fmt, JText::_($error_msg));
	}


	// check for access restrictions from the gallery
	if ($gallery !== null && $aid < intval($gallery->access)) {
		$error_msg = plg_photospot_get_option('error_msg_unauthorized', 'You are not authorized to access this gallery');
		return sprintf($msg_fmt, JText::_($error_msg));
	}


	$datasource_name = '';
	$viewer_name = '';
	$gds = trim(@$vars['gds']);
	$gvw = trim(@$vars['gvw']);

	$datasource_permissions = $params->get('datasource_permissions');
	$viewer_permissions = $params->get('viewer_permissions');
	if ($gallery !== null) {
		$gallery_params = new JParameter($gallery->params);

		if ($datasource_permissions == 'default')
			$datasource_permissions = $gallery_params->get('datasource_permissions', '');

		if ($viewer_permissions == 'default')
			$viewer_permissions = $gallery_params->get('viewer_permissions', '');
	}


	if ($gds != '' && $datasource_permissions == 'allow_all')
		$datasource_name = $gds;
	else if ($gallery !== null)
		$datasource_name = $gallery->datasource;

	if ($gvw != '' && $viewer_permissions == 'allow_all')
		$viewer_name = $gvw;
	else if ($gallery !== null)
		$viewer_name = $gallery->viewer;

	if ($datasource_name == '' || $viewer_name == '')
		return sprintf($msg_fmt, JText::_('Missing gallery information'));

	if ($gallery !== null) {
		$datasource_params = new JParameter($gallery->datasource_params);
		$viewer_params = new JParameter($gallery->viewer_params);
	}
	else {
		$datasource_params = new JParameter('');
		$viewer_params = new JParameter('');
	}

	if ($datasource_permissions == 'allow_params' || $datasource_permissions == 'allow_all')
		foreach ($vars as $k => $v)
			$datasource_params->set($k, $v);

	if ($viewer_permissions == 'allow_params' || $viewer_permissions == 'allow_all')
		foreach ($vars as $k => $v)
			$viewer_params->set($k, $v);

	ob_start();
	require($show_gallery_filename);
	$result = ob_get_contents();
	ob_end_clean();

	return '<div class="photospot_cnt">' . $result . '</div>';
}

function plg_photospot(&$row, &$params, $page = 0) {
	// simple performance check to determine whether bot should process further
	if (strpos($row->text, '{photospot ') === false)
		return true;

	$row->text = preg_replace_callback('~{photospot ([^}]*)}~', plg_photospot_cb, $row->text);
}

?>